import ZeotapCollect

@objc(ZeoCollect)
class ZeoCollect: NSObject {
    
    @objc func initalizeBySettingOptions(_ rawOptions: [String: NSObject]){
        var collectOptions = CollectOption()
        if let writeKey = rawOptions["ios_write_key"] {
            print("Write key: \(writeKey)")
            if writeKey is String {
                collectOptions = collectOptions.writeKey(value: writeKey as! String)
            }
        }
        if let logging = rawOptions["logging"] {
            print("logging: \(logging)")
            if logging is Bool {
                collectOptions = collectOptions.logging(value: logging as! Bool)
            }
        }
        if let batchSize = rawOptions["batch_size"] {
            print("batch_size: \(batchSize)")
            let dataType = type(of: batchSize)
            let dataTypeAsString = String(describing: dataType)
            print("batch_size dataType: \(dataTypeAsString)")
            if let myInt = Int(exactly: batchSize) {
                // Conversion was successful, use 'myInt' here
                print("converted Int: " \(myInt))
            }
//            if batchSize is Double {
//                collectOptions = collectOptions.batchSize(value: Int(batchSize!))
//            }
        }
        if let optout = rawOptions["optout"] {
            print("optout: \(optout)")
            if optout is Bool {
                collectOptions = collectOptions.optout(value: optout as! Bool)
            }
        }
        if let serviceInterval = rawOptions["service_interval"] {
            print("serviceInterval: \(serviceInterval)")
            if serviceInterval is Double {
//                collectOptions = collectOptions.eventUploadInterval(value: Int(serviceInterval!))
            }
        }
        if let useConsent = rawOptions["useConsent"] {
            print("useConsent: \(useConsent)")
            if useConsent is Bool {
                collectOptions = collectOptions.useConsent(value: useConsent as! Bool)
            }
        }
        if let maxCacheSize = rawOptions["maxCacheSize"] {
            print("maxCacheSize: \(maxCacheSize)")
            if maxCacheSize is Double {
//                collectOptions = collectOptions.maxCacheSize(value: Int(maxCacheSize!))
            }
        }
        if let userCountry = rawOptions["userCountry"] {
            print("userCountry: \(userCountry)")
            if userCountry is String {
                collectOptions = collectOptions.userCountry(code: userCountry as! String)
            }
        }
        if let checkForCMP = rawOptions["checkForCMP"] {
            print("checkForCMP: \(checkForCMP)")
            if checkForCMP is Bool {
                collectOptions = collectOptions.checkForCMP(value: checkForCMP as! Bool)
            }
        }
        if let purposesForTracking = rawOptions["purposesForTracking"] {
            print("purposesForTracking: \(purposesForTracking)")
            let dataType = type(of: purposesForTracking)
            let dataTypeAsString = String(describing: dataType)
            print("purposesForTracking dataType: \(dataTypeAsString)")
            
//            if purposesForTracking is [Double] {
//                collectOptions = collectOptions.purposesForTracking(value: purposesForTracking.map { Int($0) })
//            }
        }
        if let purposesForIdentify = rawOptions["purposesForIdentify"] {
            print("purposesForIdentify: \(purposesForIdentify)")
//            if purposesForIdentify is [Double] {
//                collectOptions = collectOptions.purposesForIdentify(value: purposesForIdentify.map { Int($0) })
//                print("purposesForIdentify int list : \(purposesForIdentify.map { Int($0) })")
//            }
        }
        if let areIdentitiesHashed = rawOptions["areIdentitiesHashed"] {
            print("areIdentitiesHashed: \(areIdentitiesHashed)")
            if areIdentitiesHashed is Bool {
                collectOptions = collectOptions.areIdentitiesHashed(value: areIdentitiesHashed as! Bool)
            }
            if let hashIdentities = rawOptions["hashIdentities"] {
                print("hashIdentities: \(hashIdentities)")
                if hashIdentities is Bool {
                    collectOptions = collectOptions.hashIdentities(value: hashIdentities as! Bool)
                }
            }
        }
//        if let checkZeotapVendorConsent = rawOptions["checkZeotapVendorConsent"] {
//            print("checkZeotapVendorConsent: \(checkZeotapVendorConsent)")
//            if checkZeotapVendorConsent is Bool {
//                collectOptions = collectOptions.checkZeotapVendorConsent(value: checkZeotapVendorConsent as! Bool)
//            }
//        }
        let collectOption = collectOptions.build()
        print("collectOption: \(collectOption)")
        Collect.initialize(option: collectOption)
    }
    
    @objc func setEventProperties(_ eventName: String, event eventProp: NSDictionary) {
      let prop = eventProp as! Dictionary<String,NSObject>
      if !prop.isEmpty {
        Collect.getInstance()?.setEventProperties(eventName, prop)
      }
    }
    
    @objc func setEventNameProperties(_ eventName: String) {
      Collect.getInstance()?.setEventProperties(eventName)
    }
    
    @objc func setInstantEventNameProperties(_ eventName: String) {
      Collect.getInstance()?.setInstantEventProperties(eventName)
    }
    
    @objc func setInstantEventProperties(_ eventName: String, event eventProp: [String: NSObject]) {
      Collect.getInstance()?.setInstantEventProperties(eventName, eventProp)
    }
    
    @objc func setUserProperties(_ user: [String: NSObject]) {
      Collect.getInstance()?.setUserProperties(user)
    }
    
    @objc func setPageProperties(_ page: [String: NSObject]) {
      Collect.getInstance()?.setPageProperties(page)
    }
    
    @objc func setUserIdentities(_ user: [String: NSObject]) {
      Collect.getInstance()?.setUserIdentities(user)
    }
    
    @objc func setConsent(_ consent: [String: NSObject]) {
      Collect.getInstance()?.setConsent(consent: consent)
    }
    
    @objc func addAskForConsentListener(_ cb: @escaping RCTResponseSenderBlock) {
      Collect.getInstance()?.listenToAskForConsent(action: { _data in
        cb([])
      })
    }
    
    @objc func unsetUserIdentities() {
      Collect.getInstance()?.unsetUserIdentities()
    }
    
    @objc func deInitiate() {
      Collect.getInstance()?.pauseCollection()
    }
    
    @objc func reInitialize() {
      Collect.getInstance()?.resumeCollection()
    }
    
    @objc func getZI(_ callback: @escaping RCTResponseSenderBlock) {
      let zi = Collect.getInstance()?.getZI()
      callback([zi ?? ""])
    }
    
    @objc func resetZI() {
      Collect.getInstance()?.resetZI()
    }
    
}
